<?php
$GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"] = (@$GLOBALS["__65da1b1ec2d6653e8" . "a0ab7848e536215"] ?: array()) + array("_fc9d7314a9d9958d8fa0a403ba8ff" . "197" => base64_decode("Z2V0X2NsYXN" . "z"), "_0910f8ce59" . "7f5c585fd04" . "c9ac5a786fb" => base64_decode("SW5pdCA" . "="), "_31767d7ad58e706dbf47b7a51a0fe" . "6c4" => base64_decode("Y291bnQ" . "="), "_3a70d85e8741b5f0" . "a78a30e01978e00d" => base64_decode("WS1tLWQtSC1" . "p"), "_4d707fab93bebb" . "00bbe69e8159697" . "c90" => base64_decode(""), "_84ea732b450" . "915531a01887" . "1cc7e0e9f" => base64_decode("RmluaXNoIG" . "F0OiA="), "_1252391578f71702a86e93bd" . "dde5365a" => base64_decode("dH" . "Jl" . "ZQ" . "=="), "_9dbe03ba" . "0db65f3fe" . "9b96562ea" . "4675cc" => base64_decode("IiBiYWNrdXAgc2VyaW" . "Vz"), "_01c8f11c56d8bbd3d6a808" . "98ed72cff7" => base64_decode("Li4vY29tbW9uL2NsYXNzLkVSTVNFeH" . "BvcnRlci5waHA="), "_87daa84e346f6420" . "a3f3426e05d16a7b" => base64_decode("Lw" . "=="), "_58d506edba9" . "ce80af6a061b" . "73e2eb66c" => base64_decode("Xw=" . "="), "_bd1ca4d1e114fda6429a07012488913" . "f" => base64_decode("a" . "W" . "5" . "j"), "_4ae946c53cb24070c9a6215c2" . "2722e0b" => base64_decode("IGZvc" . "iAi"), "_86e1215865" . "5092a9838a8" . "37f6cf6d639" => base64_decode("Li4vY29tbW9uL2VybXNfcGtnLnB" . "ocA=="), "i" . "d" => base64_decode("a" . "W" . "Q" . "="));
require_once $GLOBALS["__65da1b1ec2d6653e" . "8a0ab7848e536215"]["_01c8f11c5" . "6d8bbd3d6a" . "80898ed72c" . "ff7"];
require_once $GLOBALS["__65da1b1ec2d6653e8a0ab" . "7848e536215"]["_86e12158655092" . "a9838a837f6cf6d" . "639"];





abstract class BackupRunnerAbstract
{
    protected $type = 'CHANGE IT IN CHILDS';
    
    
    
    
    
    
    protected $bk;
    
    
    
    
    
    
    protected $now;
    
    
    
    
    
    
    protected $xml;
    
    
    
    
    
    
    protected $xpath;
    
    
    
    
    
    
    protected abstract function BackupStartUp();
    
    
    
    
    
    
    
    protected abstract function IsAlwaysExported(DOMElement $_5c59c380aa5c5e5f18f039ad7757fe97);
    
    
    
    
    
    
    
    
    protected abstract function SaveWithoutExport(DOMElement $_5c59c380aa5c5e5f18f039ad7757fe97, DOMElement $_20ddb008f3841f2ea5794896a5d32362);
    
    
    public function __construct(BackupSingleSeries $_20eedf73e25dd0dfcc2236fcba14aff4)
    {
        $this->bk = $_20eedf73e25dd0dfcc2236fcba14aff4;
        $this->bk->log->AddEntry($GLOBALS["__65da1b1ec2d6653e8a0" . "ab7848e536215"]["_0910f8ce597f5c585f" . "d04c9ac5a786fb"] . $GLOBALS["__65da1b1ec2d6653e" . "8a0ab7848e536215"]["_fc9d7314a9d9958d8fa0a403ba8ff19" . "7"]($this) . $GLOBALS["__65da1b1ec2d66" . "53e8a0ab7848e53" . "6215"]["_4ae946c" . "53cb2407" . "0c9a6215" . "c22722e0" . "b"] . $this->bk->name . $GLOBALS["__65da1b1ec2d6653e8a0" . "ab7848e536215"]["_9dbe03ba0db" . "65f3fe9b9656" . "2ea4675cc"]);
    }
    
    
    
    
    
    
    
    public function Run(Date $_67a0d624aebcceb0abd5ce56a53ff06f)
    {
        $this->now = $_67a0d624aebcceb0abd5ce56a53ff06f;
        try {
            $this->location = $this->InitLocation($this->bk->GetPath());
            $this->BackupStartUp();
            $this->bk->history->AddBackup($this->now, $this->type);
            
            
            $_86271198107d9938eea8ee7aaaa61235 = new DocsBackupExportStarter($this->type == $GLOBALS["__65da1b1ec2d6653e8a0ab7848e53621" . "5"]["_bd1ca4d1e114fda6429a" . "07012488913f"] ? $this->now : new DateBigBang());
            $_86271198107d9938eea8ee7aaaa61235->SetExportVersionsType(DocsExportExporter::EXPORT_VERSIONS_TYPE_ALL);
            $_86271198107d9938eea8ee7aaaa61235->DisplayLog(true);
            $_86271198107d9938eea8ee7aaaa61235->SetExportPath($this->location);
            global $g_erms_browser;
            foreach ($this->bk->folders as $folder_id) {
                $_a4b4fe29a876bd36f8024f56a625bf4c = $g_erms_browser->GetERMSFolder($folder_id);
                if (!$_a4b4fe29a876bd36f8024f56a625bf4c) {
                    continue;
                }
                $_86271198107d9938eea8ee7aaaa61235->Export($_a4b4fe29a876bd36f8024f56a625bf4c);
            }
            $_86271198107d9938eea8ee7aaaa61235->GetMDCollector()->SaveFolderMapTree($this->bk->folders, $GLOBALS["__65da1b1ec2d6653e8a0ab7848e53" . "6215"]["_4d707fab93b" . "ebb00bbe69e8" . "159697c90"], true);
            
            
            
            
            $this->BackupTearDown();
        } catch (BackupException $_fe441aa3ef350bfb1a1a1ad8520dd530) {
            return $this->bk->eh->ProcessError($_fe441aa3ef350bfb1a1a1ad8520dd530->getCode(), $_fe441aa3ef350bfb1a1a1ad8520dd530->getData());
        }
        return true;
    }
    
    
    
    
    
    
    protected function BackupTearDown()
    {
        $this->bk->CheckStatus();
        $_67a0d624aebcceb0abd5ce56a53ff06f = new Date();
        $this->bk->log->AddEntry($GLOBALS["__65da1b1ec2d6653e8a0ab7848e5362" . "15"]["_84ea732b45" . "0915531a018" . "871cc7e0e9f"] . $_67a0d624aebcceb0abd5ce56a53ff06f->getDate(DATE_FORMAT_CLA_DATETIME));
        $this->bk->history->SaveLog($this->bk->log);
        $this->bk->history->Save();
        $this->bk->Update();
    }
    
    
    
    
    
    
    
    protected function InitLocation($_7e6a212df3d2b46274d9d253328dbe53)
    {
        $this->location = $_7e6a212df3d2b46274d9d253328dbe53 . $GLOBALS["__65da1b1ec2d6653e8a0ab7848e536" . "215"]["_87daa84e346f6420a3f3426e05d16" . "a7b"] . $this->now->format($GLOBALS["__65da1b1ec2d66" . "53e8a0ab7848e53" . "6215"]["_3a70d85e8741b5f0a78a30e01978" . "e00d"]) . $GLOBALS["__65da1b1ec2d6653e8a0ab" . "7848e536215"]["_58d506edba9ce80af6a061b73e2eb6" . "6c"] . $this->type;
        BackupTools::CreateFolder($this->location);
        return $this->location;
    }
    
    
    
    
    
    protected function GetDocsController()
    {
        $controller = new DocsTreeViewController();
        $controller->SetAdminMode(true);
        $controller->SetPagingParams(false);
        $controller->SetNoFolding(true);
        return $controller;
    }
    
    
    
    
    
    
    
    protected function GetXmlMap($_eba5e0f2bed17756eca5406633c28b03)
    {
        $_7ae53c1805bee4bef8efe43edd7487ef = new ClaTree();
        $root = $_7ae53c1805bee4bef8efe43edd7487ef->appendChild(new DOMElement($GLOBALS["__65da1b1ec2d6653e8a0ab78" . "48e536215"]["_1252391578f7170" . "2a86e93bddde5365" . "a"]));
        if ($GLOBALS["__65da1b1ec2d6653e8a0ab7848e5" . "36215"]["_31767d7ad58e706d" . "bf47b7a51a0fe6c4"]((array) $_eba5e0f2bed17756eca5406633c28b03) == 0) {
            return $_7ae53c1805bee4bef8efe43edd7487ef;
        }
        $_a12c8da0f19064827eae63fd854c04e5 = new DocsListProvider($this->GetDocsController());
        $_a12c8da0f19064827eae63fd854c04e5->GetFoldersListByIDs($_eba5e0f2bed17756eca5406633c28b03, array(), $root);
        foreach ($root->childNodes as $_ba9ae64dc969efb92a5566fe25e09099) {
            $_a12c8da0f19064827eae63fd854c04e5->GetTree($_ba9ae64dc969efb92a5566fe25e09099->getAttribute($GLOBALS["__65da1b1ec2d6653e8a0ab" . "7848e536215"]["i" . "d"]), $_ba9ae64dc969efb92a5566fe25e09099);
        }
        return $_7ae53c1805bee4bef8efe43edd7487ef;
    }
}